# Autooptimiser

From PanoTools.org Wiki

autooptimiser is a smart optimiser replacement for PTOptimizer and vig_optimize, it is part of the hugin suite of tools for panoramic imaging.

It is not a 100% drop-in replacement for PTOptimizer as it has a slightly different interface and some extra features:

- PTOptimizer will write the output of the optimisation into the input script file as 'o' lines, deleting any that already exist. This behaviour is a little strange, so autooptimiser writes the result to STDOUT or a new file, as is more usual for a command-line tool.
- Not clobbering the original file means that there is no need to create 'o' lines, the output file is in the same format as the input with optimised values applied to the 'i' lines.
- PTStitcher requires 'o' lines, so the output of autooptimiser isn't suitable for stitching with PTStitcher without further processing - Stitch these files with nona instead.

Additional features:

- autooptimiser can perform pairwise optimisation instead of trying to optimise all rotation parameters at the same time, this means that there is no need to pre-position images before optimisation.
- levelling the horizon in a set of images can be performed, this is the same functionality as the Straighten button in the hugin Preview window.
- auto-align mode will pick an optimisation scheme suited to the distribution of control points in the project so there is no need to specify parameters to optimise.
- autooptimiser can adjust the panorama field of view[*], dimensions and projection to suit the input images.
- the field of view of input images can be specified, this is useful as the project files created by autopano and autopano-sift don't specify the field of view of the input photos.
- autooptimiser can also perform photometric optimisation like the vig_optimize tool. Depending on the input images it selects automaticly these photometric parameters (exposure, white balance, vignetting, camera response curve) which should be optimised.

## Usage

          autooptimiser [options] project.pto

(- can be specified to read the project from stdio.)

### Description

autooptimiser works similarly to PToptimizer but with extra command- line options.

It is also different in that PToptimizer appends its output onto the input file in the form of ’o’ lines which need further processing. autooptimiser simply updates the project and writes it to a new file.

### Options

`-o file.pto` Output file. If omitted, stdout is used.

- Optimisation options (if not specified, no optimisation takes place):

`-a` Auto align mode, includes various optimisation stages, depending on the amount and distribution of the control points

`-p` Pairwise optimisation of yaw, pitch and roll, starting from first image

`-n` Optimize parameters specified in script file (like PToptimizer).

`-m` Optimize photometric parameters (the optimized parameters are automatically selected depending on project settings)

- Post-processing options:

`-l` Level horizon (works best for horizontal panoramas)

`-s` Automatically select a suitable output projection and size

- Other options:

`-q` Quiet operation (no progress is reported)

`-v HFOV` Specify horizontal field of view of input images. Used if the .pto file contains invalid HFOV values (autopano-SIFT writes .pto files with invalid HFOV)

When -a, -l, -s and -m options are used together, an operation similar to the one of the "Align" button in hugin is performed.

Retrieved from "https://wiki.panotools.org/index.php?title=Autooptimiser&oldid=13134"